#ifndef __CVirSimpleListCtrl_h__
#define __CVirSimpleListCtrl_h__

#ifdef __VIR_LIST__
#undef LV_ITEM
#define LV_ITEM MYLVITEM
#endif
#define	IMG_START_MARK  0xfe
#define	IMG_END_MARK  0xfd
#define __POS_INFO__ 610
#define __POS_GREEN_MARK__ 570

#define MAX_COLS 3
typedef struct tagMYLVITEM
{
    UINT mask;
    int iItem;
    int iSubItem;
    UINT state;
    UINT stateMask;
    LPWSTR pszText;
    int iImages[3];
    LPARAM lParam;
	LPWSTR pszTextExt[MAX_COLS-1];
	
} MYLVITEM;

//#undef LV_ITEM
//#define LV_ITEM MYLVITEM
#define SMOOTHSCROLL_TIMER_ID  0x333
#define SMOOTHSCROLL_DELAY_IN_MS 200
#define SMOOTHSCROLL_SLOW_DOWN_FACTOR 15

class CVirSimpleListCtrl 
{
public:
	CVirSimpleListCtrl(){
		//Line1 = SHLoadImageResource (NULL,  IDB_BK_LISTE_LINE1);
		//LineS = SHLoadImageResource (NULL,  IDB_BK_LISTE_LINES);
		int width,height;
#ifdef __LINE1__
		Line1.hBmp = LoadIPNImage(IDB_BK_LISTE_LINE1, &Line1.pBuf, &width, &height, TRUE);
		Line1.id = IDB_BK_LISTE_LINE1;
#endif
		LineS.hBmp = LoadIPNImage(IDB_BK_LISTE_LINES, &LineS.pBuf, &width, &height, TRUE);
		LineS.id = IDB_BK_LISTE_LINES;
		hListBK= NULL; //SHLoadImageResource (NULL,  IDB_BK_LISTE_PART);
	//	m_pszPath=NULL;
		m_nOff = 40 ;m_nSel = -1;m_nStart=0;// m_bType=0; 
		m_tick=0; m_hWnd= 0; m_nCols = 1; m_nSort = 0;m_pfnCompare=NULL; m_bVisible = TRUE;
		m_nLineHeight =42 ; m_yScrollSpeed = 0;m_nTimer=-1;m_bForceNotify= FALSE;
		m_nIconOffset = 4; m_nIDBACK=IDBI_BK_LISTE;
	}
	~CVirSimpleListCtrl(){
	//	if(m_pszPath) free(m_pszPath); m_pszPath=NULL;
#ifdef __LINE1__
		DeleteObject(Line1.hBmp);	 
#endif
		DeleteObject(LineS.hBmp);
		if(hListBK) DeleteObject(hListBK);

		for(int i=0;i<m_bmpMapS.GetSize();i++)
		 {
			 HBITMAP  hBmp = m_bmpMapS.GetValueAt(i);
			 if(hBmp)
			 {
				 DeleteObject(hBmp);
			 }
		 }
		 m_bmpMapS.RemoveAll();
		 for(int i=0;i<m_bmpMap.GetSize();i++)
		 {
			 HBITMAP  hBmp = m_bmpMap.GetValueAt(i);
			 if(hBmp)
			 {
				 DeleteObject(hBmp);
			 }
		 }
		 m_bmpMap.RemoveAll();
	}
	void Create(HWND hWnd,CRect& rc,int, DWORD dwStyle, int, int id){
		m_rcBound = rc;
 
		m_hWnd = hWnd;
		m_nVisibleCount = m_rcBound.Height()/m_nLineHeight;
		m_nID= id;
	}
	int GetSelectedIndex() const 
	{
		return m_nSel;
	};
	int InsertItem(const MYLVITEM* pItem)
	{
		MYLVITEM my;
		memset(&my,0,sizeof(my));
		memcpy(my.iImages , pItem->iImages, sizeof(my.iImages));
		//my.iImage = pItem->iImage;
		my.iItem = pItem->iItem;
		my.iSubItem = pItem->iSubItem;
		my.lParam = pItem->lParam;
		my.mask = pItem->mask;
		my.state = pItem->state;
		my.stateMask = pItem->stateMask;
		my.pszText = wcsdup(pItem->pszText);
			
		int i=0;
		for(i=0;i<MAX_COLS-1;i++)
		if(pItem->pszTextExt[i])
			my.pszTextExt[i] = wcsdup(pItem->pszTextExt[i]);
		//if(pItem->pszText2) 
		//	my.pszText2 = wcsdup(pItem->pszText2);
		int nSize = m_list.GetSize();
		if(pItem->iItem>nSize-1)
			m_list.Add(my);
		else{
			MYLVITEM u = m_list[nSize-1];
			u.iItem++;
			m_list.Add(u);
			 
			for(int i = nSize-1 ; i> my.iItem;i--)
			{
				MYLVITEM& u1 =  m_list[i-1] ;
				MYLVITEM& u2 =  m_list[i] ;
				u1.iItem++;
				memcpy(&u2,&u1,sizeof(MYLVITEM));
				
			}
			MYLVITEM& uu =  m_list[ my.iItem] ;
			memcpy(&uu,&my,sizeof(MYLVITEM));
			//m_list.SetAtIndex( my.iItem,my);
		}
		return m_list.GetSize()-1;
	};
	virtual void SortItems(int nSort)
	{
	}
	void SetItem(const MYLVITEM* pItem)
	{
		if(pItem->mask&LVIF_TEXT && pItem->iSubItem<MAX_COLS)
		{
			int i = pItem->iItem ;
			//m_list[i].pszText2=wcsdup(pItem->pszText);
			m_list[i].pszTextExt[pItem->iSubItem-1]=wcsdup(pItem->pszText);	
			
		}
		
	};
	BOOL MoveItem(int from , int to) 
	{
		int c =  m_list.GetSize() ;
		if(from>=c || to>=c) return FALSE;
		MYLVITEM a = m_list[from];
		BOOL b = m_list.RemoveAt(from);
		if(!b) return b;
		a.iItem = to;
		b= InsertItem(&a);
		if(a.pszText) free(a.pszText);
		int i;
		for(i=0;i<MAX_COLS-1;i++)
		if(a.pszTextExt[i]) free(a.pszTextExt[i]);
		return b;
	}
	BOOL DeleteItem(int i)
	{
		if(i>= m_list.GetSize()) return FALSE;
		if(m_list[i].pszText) free(m_list[i].pszText);
		int j;
		for(j=0;j<MAX_COLS-1;j++)
			if(m_list[i].pszTextExt[j]) free(m_list[i].pszTextExt[j]);
		
		m_list.RemoveAt(i);
		if(m_nSel==i) m_nSel=-1;
		Invalidate();
		return TRUE;
	}
	BOOL SelectItem(int nIndex,BOOL bNotify=TRUE){
		
		BOOL bChanged = FALSE;
		if(m_nSel!=nIndex)
		{
			bChanged = TRUE;
		}
		m_nSel = nIndex;

		if(m_nSel>=m_nStart+m_nVisibleCount)
		{
			m_nStart=m_nSel ;
		}else if(m_nSel<m_nStart)
		{
			m_nStart=m_nSel;
		}


		if(bChanged && bNotify)
		{
			NMHDR lParam ;
			lParam.code = LVN_ITEMCHANGED ;
			lParam.idFrom = m_nID ;
			::SendMessage(m_hWnd, WM_NOTIFY, m_nID ,(LPARAM)&lParam);
		}
		return TRUE;
	};
	BOOL DeleteAllItems()
	{
		int i;
		int count = m_list.GetSize();
		for(i=0;i<count;i++)
		{
			if(m_list[i].pszText) free(m_list[i].pszText);
			//if(m_list[i].pszText2) free(m_list[i].pszText2);
			int j;
			for(j=0;j<MAX_COLS-1;j++)
				if(m_list[i].pszTextExt[j]) free(m_list[i].pszTextExt[j]);
		}
		m_list.RemoveAll();
		Invalidate();
		m_nSel = -1;
		return TRUE;
	};
	void SetItemData(int n, DWORD data)
	{
		m_list[n].lParam = data;
	}
	DWORD GetItemData(int n)
	{
		if(n<m_list.GetSize())
		{
			return m_list[n].lParam ;
		}
		return 0;
	}
	int* GetItemImages(int n) const
	{
		if(n<m_list.GetSize())
			return (int*) m_list[n].iImages;
		return NULL ;
		
	}
	void SetItemImage(int n, int nSub, int id)
	{
		if(n<m_list.GetSize())
		{
			m_list[n].iImages[nSub]= id; 
		}
	}
	int GetItemText(int n,int nSub, TCHAR* szText,int len)
	{
		szText[0]=0;
		if(n<m_list.GetSize())
		{
			if(nSub==0){
				if(wcslen(m_list[n].pszText)>=len)
				{
					wcsncpy(szText, m_list[n].pszText,len-1);szText[len-1]=0;
				}
				else wcscpy(szText, m_list[n].pszText);
			}
			else {
				if( nSub< MAX_COLS && m_list[n].pszTextExt[nSub-1]) 
				{
					if(wcslen(m_list[n].pszTextExt[nSub-1])>=len)
					{
						wcsncpy(szText, m_list[n].pszTextExt[nSub-1],len-1);szText[len-1]=0;
					}else 
					wcscpy(szText, m_list[n].pszTextExt[nSub-1]);
				}
			}
		}
		return wcslen(szText);
	}
	void SetItemText(int n, int nSub , TCHAR* szText)
	{
		if(n<m_list.GetSize())
		{
			if(nSub==0) 
			{
				if(m_list[n].pszText) free(m_list[n].pszText);
				m_list[n].pszText = wcsdup(szText);
			}else if(nSub<MAX_COLS){
				if( m_list[n].pszTextExt[nSub-1]) free(m_list[n].pszTextExt[nSub-1]);
				m_list[n].pszTextExt[nSub-1] = wcsdup(szText);
			}
			
		}
	}
	void GetLineRect(int nLine, RECT* pRect)
	{
		pRect->left= m_rcBound.left;
		pRect->right = m_rcBound.right;
		pRect->top = m_rcBound.top+ m_nLineHeight*nLine;
		pRect->bottom = pRect->top + m_nLineHeight;
	}
	BOOL GetWindowRect(LPRECT prc)
	{
		prc->left=m_rcBound.left;
		prc->top =m_rcBound.top;
		prc->right=m_rcBound.right;
		prc->bottom=m_rcBound.bottom;
		return TRUE;
	}
	DWORD SetWindowLong( DWORD , DWORD)
	{

		return 0;
	}
	HFONT SetFont(HFONT hFont)
	{
		HFONT hOld = hFont;
		m_hFont = hFont;
		return hOld;
	}
	virtual BOOL InsertColumn(int nCol, const LVCOLUMN* pColumn)
	{
		if(nCol>=MAX_COLS) return 0;
		m_nColWidth[nCol] = pColumn->cx-m_nOff;
		m_nCols = nCol+1;
		return 1;
	}
	int GetItemCount()
	{
		return m_list.GetSize();
	}
	void RedrawItems(int s ,int e)
	{
		Invalidate();
	}
	DWORD DrawBK(HDC hDC) ;
	virtual DWORD DrawItem(HDC  , int nLine, CRect&rcPaint);
	void Invalidate(){
		CRect rt(m_rcBound);
		rt.left = 0;
		::InvalidateRect(m_hWnd,&rt,1);
	}
	void UpdateWindow(){};

	void EnsureVisible(int SelMark,BOOL b=FALSE)
	{
		if(SelMark>=m_nStart+m_nVisibleCount)
		{
			m_nStart = SelMark-m_nVisibleCount+1; //m_nStart++ ; 
		}else if(SelMark<m_nStart)
		{
			m_nStart = SelMark ; //m_nStart--;
		}
	}
	BOOL IsWindow(){
		return ::IsWindow(m_hWnd);
	}
	int SendMessage( UINT msg , WPARAM , LPARAM ){return 0;};
	virtual LRESULT OnLButtonUp(UINT, CPoint pt);
	virtual LRESULT OnLButtonDown(UINT, CPoint pt);
	//virtual LRESULT OnLButtonDBLClk(UINT, CPoint pt) ;
		void OnPaint(HDC hDC,CRect& rcPaint);
	//virtual int HitTest(CPoint pt, LV_HITTESTINFO* pinfo);
		void OnTimer(WPARAM);
		LRESULT OnMouseMove(UINT, CPoint pt);
	virtual void ShowWindow(int nShow)
	{
		BOOL bOld = m_bVisible;
		m_bVisible = (nShow==SW_SHOW)?TRUE:FALSE;
		if(m_bVisible!=bOld)
			Invalidate();
	}
	void  Detach()
	{

	}
	void DestroyWindow(){
		DeleteAllItems();
		m_hWnd = NULL;
	};
	BOOL IsWindowVisible()
	{
		return m_bVisible;
	}
	LRESULT OnScroll( WPARAM wParam, LPARAM lParam);
protected:
#ifdef __LINE1__
	BKIMG_T Line1;
#endif
	BKIMG_T LineS;
	//BKIMG_T Line1,LineS;
	CSimpleMap<int, HBITMAP> m_bmpMapS,m_bmpMap;
	DWORD m_tick;
	HFONT m_hFont;
	BOOL m_bVisible;
	int m_nTimer;
public:
	int m_nSort; // 0 not sort, 1 : descend  2: ascend
	PFNLVCOMPARE m_pfnCompare;
	HBITMAP hListBK;
	int m_nOff;
	CSimpleArray<MYLVITEM> m_list;
	CPoint m_pt;
	int m_yScrollSpeed;
	int m_nSel;
	int m_nStart;
	int m_nVisibleCount;
	CRect m_rcBound;
	int m_nLineHeight;
	HWND m_hWnd;
	int m_nID;
	int m_nCols;
	int m_nColWidth[MAX_COLS];
	BOOL m_bForceNotify;
	int m_nIconOffset ,m_nIDBACK;
};

#endif
